unit schAlmacenesClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_Almacenes = '{2DCC6883-DBB5-418A-A355-AA7A72F5F0CA}';

  { Data table names }
  nme_Almacenes = 'Almacenes';

  { Almacenes fields }
  fld_AlmacenesID = 'ID';
  fld_AlmacenesID_EMPRESA = 'ID_EMPRESA';
  fld_AlmacenesFECHA_ALTA = 'FECHA_ALTA';
  fld_AlmacenesCALLE = 'CALLE';
  fld_AlmacenesPROVINCIA = 'PROVINCIA';
  fld_AlmacenesPOBLACION = 'POBLACION';
  fld_AlmacenesCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_AlmacenesTELEFONO = 'TELEFONO';
  fld_AlmacenesMOVIL = 'MOVIL';
  fld_AlmacenesFAX = 'FAX';
  fld_AlmacenesPERSONA_CONTACTO = 'PERSONA_CONTACTO';
  fld_AlmacenesOBSERVACIONES = 'OBSERVACIONES';
  fld_AlmacenesFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_AlmacenesUSUARIO = 'USUARIO';
  fld_AlmacenesNOMBRE = 'NOMBRE';

  { Almacenes field indexes }
  idx_AlmacenesID = 0;
  idx_AlmacenesID_EMPRESA = 1;
  idx_AlmacenesFECHA_ALTA = 2;
  idx_AlmacenesCALLE = 3;
  idx_AlmacenesPROVINCIA = 4;
  idx_AlmacenesPOBLACION = 5;
  idx_AlmacenesCODIGO_POSTAL = 6;
  idx_AlmacenesTELEFONO = 7;
  idx_AlmacenesMOVIL = 8;
  idx_AlmacenesFAX = 9;
  idx_AlmacenesPERSONA_CONTACTO = 10;
  idx_AlmacenesOBSERVACIONES = 11;
  idx_AlmacenesFECHA_MODIFICACION = 12;
  idx_AlmacenesUSUARIO = 13;
  idx_AlmacenesNOMBRE = 14;

type
  { IAlmacenes }
  IAlmacenes = interface(IDAStronglyTypedDataTable)
  ['{5FF711CD-A427-4668-96D6-78450E64E858}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetTELEFONOValue: String;
    procedure SetTELEFONOValue(const aValue: String);
    function GetMOVILValue: String;
    procedure SetMOVILValue(const aValue: String);
    function GetFAXValue: String;
    procedure SetFAXValue(const aValue: String);
    function GetPERSONA_CONTACTOValue: String;
    procedure SetPERSONA_CONTACTOValue(const aValue: String);
    function GetOBSERVACIONESValue: IROStrings;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property MOVIL: String read GetMOVILValue write SetMOVILValue;
    property FAX: String read GetFAXValue write SetFAXValue;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
  end;

  { TAlmacenesDataTableRules }
  TAlmacenesDataTableRules = class(TDADataTableRules, IAlmacenes)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetTELEFONOValue: String; virtual;
    procedure SetTELEFONOValue(const aValue: String); virtual;
    function GetMOVILValue: String; virtual;
    procedure SetMOVILValue(const aValue: String); virtual;
    function GetFAXValue: String; virtual;
    procedure SetFAXValue(const aValue: String); virtual;
    function GetPERSONA_CONTACTOValue: String; virtual;
    procedure SetPERSONA_CONTACTOValue(const aValue: String); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property MOVIL: String read GetMOVILValue write SetMOVILValue;
    property FAX: String read GetFAXValue write SetFAXValue;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TAlmacenesDataTableRules }
constructor TAlmacenesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TAlmacenesDataTableRules.Destroy;
begin
  inherited;
end;

function TAlmacenesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_AlmacenesID].AsInteger;
end;

procedure TAlmacenesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlmacenesID].AsInteger := aValue;
end;

function TAlmacenesDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_AlmacenesID_EMPRESA].AsInteger;
end;

procedure TAlmacenesDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlmacenesID_EMPRESA].AsInteger := aValue;
end;

function TAlmacenesDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_AlmacenesFECHA_ALTA].AsDateTime;
end;

procedure TAlmacenesDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_AlmacenesFECHA_ALTA].AsDateTime := aValue;
end;

function TAlmacenesDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesCALLE].AsString;
end;

procedure TAlmacenesDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesCALLE].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesPROVINCIA].AsString;
end;

procedure TAlmacenesDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesPROVINCIA].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesPOBLACION].AsString;
end;

procedure TAlmacenesDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesPOBLACION].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesCODIGO_POSTAL].AsString;
end;

procedure TAlmacenesDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesCODIGO_POSTAL].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetTELEFONOValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesTELEFONO].AsString;
end;

procedure TAlmacenesDataTableRules.SetTELEFONOValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesTELEFONO].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetMOVILValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesMOVIL].AsString;
end;

procedure TAlmacenesDataTableRules.SetMOVILValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesMOVIL].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetFAXValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesFAX].AsString;
end;

procedure TAlmacenesDataTableRules.SetFAXValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesFAX].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetPERSONA_CONTACTOValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesPERSONA_CONTACTO].AsString;
end;

procedure TAlmacenesDataTableRules.SetPERSONA_CONTACTOValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesPERSONA_CONTACTO].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_AlmacenesOBSERVACIONES].AsString;
end;

procedure TAlmacenesDataTableRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_AlmacenesOBSERVACIONES].AsString := aValue.Text;
end;

function TAlmacenesDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_AlmacenesFECHA_MODIFICACION].AsDateTime;
end;

procedure TAlmacenesDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_AlmacenesFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TAlmacenesDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesUSUARIO].AsString;
end;

procedure TAlmacenesDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesUSUARIO].AsString := aValue;
end;

function TAlmacenesDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_AlmacenesNOMBRE].AsString;
end;

procedure TAlmacenesDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_AlmacenesNOMBRE].AsString := aValue;
end;


initialization
  RegisterDataTableRules(RID_Almacenes, TAlmacenesDataTableRules);

end.
